=== ncsa/hdf/hdflib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_NCSA_HDF_HDF4 Java)

SET (CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES (
    ${HDFJAVA_NCSA_HDF_HDF4_SOURCE_DIR}
    ${HDFJAVA_NCSA_HDF_HDF4_BINARY_DIR}
)

SET (HDFJAVA_NCSA_HDF_HDF4_SRCS
    HDFException.java
    HDFJavaException.java
    HDFArray.java
    HDFChunkInfo.java
    HDFCompInfo.java
    HDFConstants.java
    HDFDeflateCompInfo.java
    HDFDeprecated.java
    HDFIMCOMPCompInfo.java
    HDFJPEGCompInfo.java
    HDFLibrary.java
    HDFLibraryException.java
    HDFNativeData.java
    HDFNewCompInfo.java
    HDFNBITChunkInfo.java
    HDFNBITCompInfo.java
    HDFNotImplementedException.java
    HDFOldCompInfo.java
    HDFOldRLECompInfo.java
    HDFRLECompInfo.java
    HDFSKPHUFFCompInfo.java
    HDFSZIPCompInfo.java
    HDFTable.java
)

INCLUDE_DIRECTORIES (${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${HDFJAVA_NCSA_HDF_LIB_CORENAME}.dir/ncsa/hdf/hdflib)

SET (CMAKE_JNI_TARGET TRUE)
SET (CMAKE_JAVA_TARGET_VERSION ${HDFJAVA_PACKAGE_VERSION})

ADD_JAR (${HDFJAVA_NCSA_HDF_LIB_TARGET} ${HDFJAVA_NCSA_HDF_HDF4_SRCS})
INSTALL_JAR (${HDFJAVA_NCSA_HDF_LIB_TARGET} ${HJAVA_INSTALL_LIB_DIR} libraries)
IF (NOT WIN32)
  INSTALL_JNI_SYMLINK (${HDFJAVA_NCSA_HDF_LIB_TARGET} ${HJAVA_INSTALL_LIB_DIR} libraries)
ENDIF (NOT WIN32)
GET_TARGET_PROPERTY(${HDFJAVA_NCSA_HDF_LIB_TARGET}_JAR_FILE ${HDFJAVA_NCSA_HDF_LIB_TARGET} JAR_FILE)
SET_GLOBAL_VARIABLE (HDFJAVA_JARS_TO_EXPORT "${HDFJAVA_JARS_TO_EXPORT};${${HDFJAVA_NCSA_HDF_LIB_TARGET}_JAR_FILE}")
GET_TARGET_PROPERTY(${HDFJAVA_NCSA_HDF_LIB_TARGET}_CLASSPATH ${HDFJAVA_NCSA_HDF_LIB_TARGET} CLASS_DIR)
SET_GLOBAL_VARIABLE (HDFJAVA_CP_TO_EXPORT "${HDFJAVA_CP_TO_EXPORT};${${HDFJAVA_NCSA_HDF_LIB_TARGET}_CLASSPATH}")
ADD_DEPENDENCIES (${HDFJAVA_NCSA_HDF_LIB_TARGET} ${HDFJAVA_JNI_HDF_LIB_TARGET})
