=== ncsa/hdf/object/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_NCSA_HDF_OBJECT)

SET (CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES (
    ${HDFJAVA_NCSA_HDF_OBJECT_SOURCE_DIR}
    ${HDFJAVA_NCSA_HDF_OBJECT_BINARY_DIR}
)

SET (HDFJAVA_NCSA_HDF_OBJECT_SRCS
    Attribute.java
    CompoundDS.java
    DataFormat.java
    Dataset.java
    Datatype.java
    FileFormat.java
    Group.java
    HObject.java
    Metadata.java
    ScalarDS.java
)

INCLUDE_DIRECTORIES (${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${HDFJAVA_NCSA_OBJECT_LIB_CORENAME}.dir/ncsa/hdf/object)

ADD_JAR (${HDFJAVA_NCSA_OBJECT_LIB_TARGET} ${HDFJAVA_NCSA_HDF_OBJECT_SRCS})
INSTALL_JAR (${HDFJAVA_NCSA_OBJECT_LIB_TARGET} ${HJAVA_INSTALL_LIB_DIR} libraries)
GET_TARGET_PROPERTY(${HDFJAVA_NCSA_OBJECT_LIB_TARGET}_JAR_FILE ${HDFJAVA_NCSA_OBJECT_LIB_TARGET} JAR_FILE)
SET_GLOBAL_VARIABLE (HDFJAVA_JARS_TO_EXPORT "${HDFJAVA_JARS_TO_EXPORT};${${HDFJAVA_NCSA_OBJECT_LIB_TARGET}_JAR_FILE}")
ADD_DEPENDENCIES (${HDFJAVA_NCSA_OBJECT_LIB_TARGET} ${HDFJAVA_NCSA_HDF5_LIB_TARGET} ${HDFJAVA_NCSA_HDF_LIB_TARGET})

ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_OBJECT_SOURCE_DIR}/fits      fits)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_OBJECT_SOURCE_DIR}/h4        h4)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_OBJECT_SOURCE_DIR}/h5        h5)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_OBJECT_SOURCE_DIR}/nc2       nc2)
