=== debian/changelog ===
jhdf (2.8.0-5) unstable; urgency=low

  * Building with gcj fails. Build only with the openjdk-6

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 11 Mar 2012 16:07:17 +0100

jhdf (2.8.0-4) unstable; urgency=low

  * Potential fix for the kfreebsd-* archs (Closes: #661560)
  * Standards-Version updated to version 3.9.3

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 28 Feb 2012 21:46:03 +0100

jhdf (2.8.0-3) unstable; urgency=low

  * hdfview was failing spaces existed in the path (LP: #919000)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 21 Jan 2012 14:43:24 +0100

jhdf (2.8.0-2) unstable; urgency=low

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 18 Jan 2012 18:50:49 +0100

jhdf (2.8.0-1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 18 Dec 2011 23:59:59 +0100
